
#include "MySort.h"

/*
	迭arr  ̸, left right   ε ̴.
	QuickSort Լ   迭 arr left right  Ѵ.
	Ĺ ̴.
*/
void QuickSort(Merchant arr[], int left, int right)
{
	int pivot;		//	߽ 

	if (left < right)
	{
		/*
			Ǻ  ڸ ã´. Ǻ  ڸ ã, Ǻ ߽  Ǻ  
			 Ǻ ū  Ѵ.
		*/
		pivot = Partition(arr, left, right);

		/*	pivot ߽, left pivot - 1   	*/
		QuickSort(arr, left, pivot - 1);

		/*	pivot ߽, pivot + 1 right   	*/
		QuickSort(arr, pivot + 1, right);
	}
}

/*
	迭arr  ̸, left right   ε ̴.
	Լ ϴ  Ǻ  ڸ ã  Ѵ.
	Լ ϰ  ڸ ã Ǻ ε ̴.
*/
int Partition(Merchant arr[], int left, int right)
{
	int pivot = arr[left].Price;	//	   ʿ ġ ͸ Ǻ 

	int low = left + 1;		//	Ǻ   ʿ ġ  ε
	int high = right;		//	Ǻ   ʿ ġ  ε

	while (low <= high)
	{
		/*	Ǻ ū    low   ̵	*/
		while (arr[low].Price <= pivot && low <= right)
			low++;

		/*	Ǻ     high   ̵	*/
		while (arr[high].Price >= pivot && high >= (left + 1))
			high--;

		/*	low high Ǹ, low high Ű  ȯ ʴ´.	*/
		if (low <= high)
			Swap(arr, low, high);
	}

	/*
		Ǻ high Ű  ȯϹǷν,
		Ǻ  ڸ ã.
		Ǻ ߽,  Ǻ   ϰ,  Ǻ ū  .
	*/
	Swap(arr, left, high);

	return high;			//	Ű Ǻ ε  
}

/*	迭  ε idx1 idx2 ִ  ȯ	*/
void Swap(Merchant arr[], int idx1, int idx2)
{
	Merchant temp = arr[idx1];
	arr[idx1] = arr[idx2];
	arr[idx2] = temp;
}
